#include<bonnet.h>

int check_block_bitmap(int blkno)
{
    struct ext2_group_desc *gd;
    int byte,bit;
    char *block = new_balloc(1);

    if(blkno < 0 )
        return -1;


    gd = fs_info->gd;
    gd   +=BLOCK2GROUP(blkno);

    byte  = BLOCK2TABLE(blkno) / 8;
    bit   = BLOCK2TABLE(blkno) % 8;

    bread(gd->bg_block_bitmap,block,1);

    if(bit < 1)
        bit = 1;

    if((block[byte]) & (1 << (bit-1)) >= 1)
        return 1;
    else return -1;
}

int check_inode_bitmap(int inodno)
{
    struct ext2_group_desc *gd;
    int byte,bit;
    char *block = new_balloc(1);

    if(inodno < 0 )
        return -1;


    gd = fs_info->gd;
    gd   +=INODE2GROUP(inodno);

    byte  = INODE2TABLE(inodno) / 8;
    bit   = INODE2TABLE(inodno) % 8;

    bread(gd->bg_inode_bitmap,block,1);

    if(bit < 1)
        bit = 1;

    if((block[byte]) & (1 << (bit-1)) >= 1)
        return 1;
    else return -1;
}
