#include<bonnet.h>


static void lba_to_chs(int lba, int *cyl, int *head, int *sect)
{
    *sect = lba & 0xff; // 255
    lba >>= 8;
    *cyl = lba & 0xffff; // 66536
    lba >>= 16;
    *head = (lba & 0xf) | 0x40; // 16
}


int ide_read(int lba,char *buf)
{
	char s;

	int sec;
	int head;
	int cyl;

	if(ioperm(0x1f0,8,1))
	{
		printf("Access Denied\n");
		exit(1);
	}

	lba_to_chs(lba,&cyl,&head,&sec);

	outb(head,0x1f6); // drive/head, drive 0 selected
	outb(1,0x1f2);  // count number
	outb(sec,0x1f3);  // sector number
	outb(cyl&0xff,0x1f4);  // cylinder low
	outb((cyl&0xff00)>>8,0x1f5);  // cylinder high
	outb(0x20,0x1f7); // command register

	while( ((s=inb(0x1f7)) & 0x8) == 0); //status register

	insw(0x1f0,buf,256); // reading from data register
	ioperm(0x1f0,8,0);

	return 0;
}

int ide_write()
{

	return 0;
}

