#include<bonnet.h>

static void lba_to_chs(int lba, int *cyl, int *head, int *sect)
{
    *sect = lba & 0xff; // 255
    lba >>= 8;
    *cyl = lba & 0xffff; // 66536
    lba >>= 16;
    *head = (lba & 0xf) | 0x40; // 16
}

int ide_write(int lba,char *buf,int count)
{
	char s;

	int sec;
	int head;
	int cyl;

	if(ioperm(0x1f0,8,1))
	{
		printf("Access Denied\n");
		exit(1);
	}

	lba_to_chs(lba,&cyl,&head,&sec);

	while((inb(0x1f7) & 0x80) == 0x80);

	outb(head,0x1f6); // drive/head, drive 0 selected
	sdelay();
	outb(count,0x1f2);  // count number
	sdelay();
	outb(sec,0x1f3);  // sector number
	sdelay();
	outb(cyl&0xff,0x1f4);  // cylinder low
	sdelay();
	outb((cyl&0xff00)>>8,0x1f5);  // cylinder high
	sdelay();
	outb(0x30,0x1f7); // command register
	sdelay();

	while( ((s=inb(0x1f7)) & 0x80) == 0x80); //status register

	outsw(0x1f0,buf,256*count); // reading from data register
	ioperm(0x1f0,8,0);

	return 0;
}

int ide_read(int lba,char *buf,int count)
{
	char s;

	int sec;
	int head;
	int cyl;

	if(ioperm(0x1f0,8,1))
	{
		printf("Access Denied\n");
		exit(1);
	}

	lba_to_chs(lba,&cyl,&head,&sec);

	while((inb(0x1f7) & 0x80) == 0x80);

	outb(head,0x1f6); // drive/head, drive 0 selected
	sdelay();
	outb(count,0x1f2);  // count number
	sdelay();
	outb(sec,0x1f3);  // sector number
	sdelay();
	outb(cyl&0xff,0x1f4);  // cylinder low
	sdelay();
	outb((cyl&0xff00)>>8,0x1f5);  // cylinder high
	sdelay();
	outb(0x20,0x1f7); // command register
	sdelay();

	while( ((s=inb(0x1f7)) & 0x8) == 0);
	
	insw(0x1f0,buf,256*count); // reading from data register
	ioperm(0x1f0,8,0);

	return 0;
}

static int read_geometry(int baseport,int masterslave)
{
	/*
	int temp;
	char s;
	char buf[512];

	temp = ( masterslave << 4 ) | 0xe0;
	outb(temp,baseport + HDD_DRIVE_HEAD);
	outb(HDD_IDENTIFY_COMMAND,baseport+HDD_COMMAND);

	while( ((s=inb(0x1f7)) & 0x8) == 0); //status register
	insw(baseport+HDD_DATA,buf,256); // reading from data register
	*/
}

int ide_auto_detection()
{

}
