#include<bonnet.h>

struct pentry
{
	unsigned flag     :  8;
	unsigned start    : 24;
	unsigned sys_flag :  8;
	unsigned end      : 24;	
	unsigned rel      : 32;
	unsigned nsec     : 32;
} __attribute__((packed));

static struct pentry *pe;

static void parse_partition_table(char *table,int no)
{
	char *ptr;

	if(no < 1)
		return;

	pe = (struct pentry *)malloc(sizeof(struct pentry));
	ptr = &table[446+ (no-1)*16];

	memcpy(pe , ptr,16);

	/*
	printf("flag = 0x%x\n",pe->flag);
	printf("start = %d\n",pe->start);
	printf("sys_flag = %d\n",pe->sys_flag);
	printf("end = %d\n",pe->end);
	printf("rel = %d\n",pe->rel);
	printf("nsec = %d\n",pe->nsec);
	printf("\n\n");
	*/

	fs_info->sec_start = pe->rel;
	fs_info->sec_count = pe->nsec;
}

void ext2_init()
{
	fs_info = (struct file_system_info *)malloc(sizeof(struct file_system_info));

	/* ӽ 4k    */
	fs_info->blksize = 4096;

	printf("Initializing ext2fs...");
}

/*****************************************
 *
 * Mount ext2 filesystem
 *
 * Input : drive number, partition number
 *
 *****************************************/

int mount(int drvno,int partno)
{
	#define BLKSIZE 4096
	struct ext2_inode ii;
	struct ext2_inode *test;
	struct ext2_dir_entry dentry;
	char buffer[SECSIZE];
	char buffer2[BLKSIZE];
	char *pool;
	char *ptr;

	int tmp;

	int i=0;

	// Data Structure Initialization
	pool	= (char *)malloc(BLKSIZE * 5);

	// Read one sector and parse partition table
	getsect(0,buffer,1);
	parse_partition_table(buffer,partno);

	// Read a five(0~5) blocks
	getblk(0,pool,5);

	// Get Superblock
	ptr = pool + 1024;
	memcpy(&fs_info->sb,ptr,1024);

	// set block size
	switch(fs_info->sb.s_log_block_size)
	{
		case 0:
				fs_info->blksize = 1024;
				break;
		case 1:
				fs_info->blksize = 2048;
				break;
		case 2:
				fs_info->blksize = 4096;
				break;
	}
	print_super_block(&fs_info->sb);

	// How many Group descriptors?
	fs_info->max_gd_count = fs_info->sb.s_blocks_count / fs_info->sb.s_blocks_per_group;
	fs_info->gd = (struct ext2_group_desc *)\
		malloc(fs_info->max_gd_count * sizeof(struct ext2_group_desc));

	// Get Group descriptors
	ptr = pool + BLKSIZE; // 1 block
	memcpy(fs_info->gd,ptr,32 * fs_info->max_gd_count);

	//--------------------------------------------------------------
	//         T E S T {Zone}                                      \
	//--------------------------------------------------------------
	//--------------------------------------------------------------

/*************************************
 *
	namei("/kyo/kyokyo");
	return;
	printf("(%d)",is_imap_set(130822));
	i=0;
	test=inode_get(130821);

	while(i < 15)
	{
		//printf("{%d}\t",test->i_block[i]);
		i++;
	}
	get_block(262720,buffer2,1);
	write(1,buffer2,BLKSIZE);
	memcpy(&tmp,buffer2,4);
	printf("\n\nint : %d",tmp);
	//memcpy(&dentry,buffer2,sizeof(struct ext2_dir_entry));
	
	return 1;
**************************************/

}
