#include<bonnet.h>

static char *token;
static char tmp[255];

/*************************************
 *
 *  Find inode by name
 *
 **************************************/

inode_t find_inode_by_name(inode_t base,char *dir)
{
	struct ext2_inode *inode;
	struct ext2_dir_entry *dentry;
	block_t blk;
	int i=0;

	// Initialization Data Structure
	blk = new_balloc(1);
	dentry = malloc(sizeof(struct ext2_dir_entry));

	// allocate base inode
	inode = iget(base);

	if(!ISDIR(inode->i_mode))
		return -1;

	// 1. access i_blocks[0~12], [13] [14] [15]
 	getblk(inode->i_block[0],blk,1);	

	/*************************************
	 *  FIXME
	 *  
	 *   ȿ 丮 ̸ ִٰ ߱⶧
 	 *    100 ̻϶  ߻Ѵ  
	 **************************************/

	while(1)
	{
		memcpy(dentry,blk,sizeof(struct ext2_dir_entry));

		dentry->name[dentry->name_len]='\0';
		if(strcmp(dentry->name,dir) == 0)
				return dentry->inode;
		else blk+=dentry->rec_len;	

		/* end */
		if(dentry->rec_len == 0)
				return -4;
	}	
}

static int init_token(char *s)
{
	if(*s == '\0')
		return 0;

	token = (char *)malloc(strlen(s));
	strcpy(token,s);

	return 1;
}

static char *next_token()
{
	int i=0;

	if(*token == '\0')
			return NULL;
	token++;
	i=0;

	while(*token != '\0' && *token != '/')
	{
		tmp[i] = *token;
		i++;	
		token++;
	}
	tmp[i]='\0';

	return tmp;	
}

/**************************************
 *
 *  Path  to   Inode
 *
 **************************************/
inode_t namei(char *path)
{
	inode_t curi = EXT2_ROOT_INO;
	char *ptr;
	int i,tmp;

	if(init_token(path) == 0)
			return -1;

	while((ptr=next_token()) != NULL)
	{
		tmp = find_inode_by_name(curi,ptr);

		if(tmp == -1)
			break;
		else curi = tmp;
	}
	
	if(next_token() == NULL)
		return curi;
	else return -1;
}
